// zGoGUIView.cpp : implementation of the CZGoGUIView class
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CZGoGUIView

IMPLEMENT_DYNCREATE(CZGoGUIView, CView)

BEGIN_MESSAGE_MAP(CZGoGUIView, CView)
	ON_MESSAGE(WM_DRAW_BOARD, drawBoard)
	ON_MESSAGE(WM_SHIFT_TIMER, shiftTimer)
	ON_MESSAGE(WM_SET_CURRENT_COLOR, setCurrentColor)
	//{{AFX_MSG_MAP(CZGoGUIView)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_GO_COMPUTERMOVE, OnGoComputermove)
	ON_COMMAND(ID_GO_OPTIONS, OnGoOptions)
	ON_COMMAND(ID_GO_PASS, OnGoPass)
	ON_COMMAND(ID_GO_UNDOMOVE, OnGoUndomove)
	ON_COMMAND(ID_GO_SHOWDRAGONS, OnGoShowdragons)
	ON_COMMAND(ID_GO_SHOWWORMS, OnGoShowworms)
	ON_COMMAND(ID_GO_SCORE, OnGoScore)
	ON_COMMAND(ID_GO_COMPUTERPLAYBOTH, OnGoComputerplayboth)
	ON_COMMAND(ID_GO_STOPCOMPUTERPLAYBOTH, OnGoStopcomputerplayboth)
	ON_COMMAND(ID_NEVIGATE_TOP, OnNevigateTop)
	ON_COMMAND(ID_NEVIGATE_BACKWARD, OnNevigateBackward)
	ON_COMMAND(ID_NEVIGATE_FORWARD, OnNevigateForward)
	ON_COMMAND(ID_NEVIGATE_END, OnNevigateEnd)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()



extern zMessageBox m_messageBox;


UINT computerPlayBothProc(LPVOID pParam)
{
	int currentColor = 1;
	MovePara* movePara = (MovePara*)pParam;
	for (int i=0;i<360;i++) {
		if (currentColor == 2) currentColor = 1;
		else currentColor = 2;
		z_computer_move(&movePara->passes, currentColor, &movePara->i, &movePara->j);
		::PostMessage(movePara->m_hwndDrawBoard,WM_SHIFT_TIMER,0,0);
		::PostMessage(movePara->m_hwndDrawBoard,WM_DRAW_BOARD,0,0);
		::PostMessage(movePara->m_hwndDrawBoard,WM_SET_CURRENT_COLOR,0,0);
		if (movePara->passes == 2) break;
		if (WaitForSingleObject(movePara->m_hEventKillComputerPlayBothThread, 0)
			== WAIT_OBJECT_0) break;
	}
	SetEvent(movePara->m_hEventComputerPlayBothThreadKilled);
	return 0;
}

void CZGoGUIView::OnGoStopcomputerplayboth() 
{
	DWORD dwExitCode;
	if (m_pComputerPlayBothThread != NULL) {
		if (GetExitCodeThread(m_pComputerPlayBothThread->m_hThread, &dwExitCode) &&
			dwExitCode == STILL_ACTIVE)
		{
			m_messageBox.Message("m_hEventKillComputerPlayBothThread ","begin");
			SetEvent(m_hEventKillComputerPlayBothThread);
			WaitForSingleObject(m_hEventComputerPlayBothThreadKilled, INFINITE);
			m_messageBox.Message("m_hEventKillComputerPlayBothThread ","end");
			delete movePara;
		}
	}
	m_pComputerPlayBothThread = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CZGoGUIView construction/destruction

CZGoGUIView::CZGoGUIView()
{
	theApp = (CZGoGUIApp*) AfxGetApp();
	goOption.board_size = 19;
	goOption.computerPlay = EMPTY;
	goOption.handicap = 0;
	goOption.komi = 5.5;
	goOption.timer = 3600;
	bTimer.setTime(goOption.timer);
	wTimer.setTime(goOption.timer);
	bTimer.start();
	passes = 0;
	int argc = 1;
	char* argv[1];
	argv[0] = "aaa";
	m_messageBox.Message("goOption.board_size= ",goOption.board_size);
	linkMain(&goOption, argc, argv);
	currentMoveNum=0;
	//dcCreated = FALSE;
	movePara = new MovePara();
	m_hEventKillComputerPlayBothThread = CreateEvent(NULL, FALSE, FALSE, NULL); // auto reset, initially reset
	m_hEventComputerPlayBothThreadKilled = CreateEvent(NULL, FALSE, FALSE, NULL); // auto reset, initially reset
	movePara->m_hEventKillComputerPlayBothThread = m_hEventKillComputerPlayBothThread;
	movePara->m_hEventComputerPlayBothThreadKilled = m_hEventComputerPlayBothThreadKilled;
	computerPlayBoth = FALSE;
	m_pComputerPlayBothThread = NULL;
}

CZGoGUIView::~CZGoGUIView()
{
	theApp->numBoardView--;
}

BOOL CZGoGUIView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CZGoGUIView drawing

void CZGoGUIView::OnDraw(CDC* pDC)
{
	CZGoGUIDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	drawBoard();
	m_messageBox.Message("OnDraw ","9");
}

/////////////////////////////////////////////////////////////////////////////
// CZGoGUIView printing

BOOL CZGoGUIView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CZGoGUIView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CZGoGUIView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CZGoGUIView diagnostics

#ifdef _DEBUG
void CZGoGUIView::AssertValid() const
{
	CView::AssertValid();
}

void CZGoGUIView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CZGoGUIDoc* CZGoGUIView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CZGoGUIDoc)));
	return (CZGoGUIDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CZGoGUIView message handlers

void CZGoGUIView::drawBoard()
{
	try {
		m_messageBox.Message("drawBoard ","1");
		CClientDC *pDC;;
		pDC = new CClientDC(this);
			
		// FROM DRAWCLI
		CDC dc;
		CDC* pDrawDC = pDC;
		CBitmap bitmap;
		CBitmap* pOldBitmap;

		// only paint the rect that needs repainting
		CRect client;
		pDC->GetClipBox(client);
		CRect rect = client;
		//DocToClient(rect);

		if (!pDC->IsPrinting())
		{
			// draw to offscreen bitmap for fast looking repaints
			if (dc.CreateCompatibleDC(pDC))
			{
				if (bitmap.CreateCompatibleBitmap(pDC, rect.Width(), rect.Height()))
				{
					OnPrepareDC(&dc, NULL);
					pDrawDC = &dc;

					// offset origin more because bitmap is just piece of the whole drawing
					dc.OffsetViewportOrg(-rect.left, -rect.top);
					pOldBitmap = dc.SelectObject(&bitmap);
					dc.SetBrushOrg(rect.left % 8, rect.top % 8);

					// might as well clip to the same rectangle
					dc.IntersectClipRect(client);
				}
			}
		}

		goBoard.drawBoardbase(pDrawDC);
		drawBoardData(pDrawDC);

		if (pDrawDC != pDC)
		{
			pDC->SetViewportOrg(0, 0);
			pDC->SetWindowOrg(0,0);
			pDC->SetMapMode(MM_TEXT);
			dc.SetViewportOrg(0, 0);
			dc.SetWindowOrg(0,0);
			dc.SetMapMode(MM_TEXT);
			pDC->BitBlt(rect.left, rect.top, rect.Width(), rect.Height(),
				&dc, 0, 0, SRCCOPY);
			dc.SelectObject(pOldBitmap);
		}

		delete pDC;
	} catch (...)	{
	}
}

void CZGoGUIView::drawBoardData(CDC* dc)
{
	int i,j,k;
	int color,pos;
	int isEmpty=TRUE;
	try {
		getGoData(&goData);
		/*
		for (i = 0; i < goData.board_size; i++) {
			for (j = 0; j < goData.board_size; j++) {
				color = goData.board[POS(i,j)];
				if (color > 0) {
					goBoard.drawStone(&dc, i, j, color, FALSE);
				}
			}
		}
		*/
		//for (k = 0; k < goData.move_history_pointer; k++) {
		if (computerPlayBoth) {
			currentMoveNum = goData.move_history_pointer;
		}
		for (k = 0; k < currentMoveNum; k++) {
			isEmpty=FALSE;
			pos = goData.move_history_pos[k];
			i = I(pos);
			j = J(pos);
			//color = goData.move_history_color[k];
			color = goData.board[POS(i,j)];
			if (color > 0) {
				goBoard.drawStone(dc, i, j, color, FALSE);
			}
		}
		if (!isEmpty) {
			goBoard.drawStone(dc, i, j, color, TRUE);
			//goBoard.drawStone(dc, last_i, last_j, last_color, TRUE);
		}
		UpdateStatusBar();
	} catch (...)	{
	}
}

void CZGoGUIView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	try {
		setCurrentColor();
		m_messageBox.Message("OnLButtonDown, currentColor= ", currentColor);
		CPoint goBoardPoint;
		goBoard.screenCoorToBoardCoor(point, &goBoardPoint);
		z_user_move(goBoardPoint.x, goBoardPoint.y, currentColor);
		//last_i = goBoardPoint.x;
		//last_j = goBoardPoint.y;
		//last_color = currentColor;
		currentMoveNum++;
		shiftTimer();
		drawBoard();

		if (goOption.computerPlay != EMPTY) {
			OnGoComputermove();
		}
	} catch (...)	{
	}
	CView::OnLButtonDown(nFlags, point);
}

void CZGoGUIView::OnGoComputermove() 
{
	try {
		setCurrentColor();
		m_messageBox.Message("OnComputerMove, 1, currentColor=", currentColor);
		z_computer_move(&passes, currentColor, &last_i, &last_j);
		//last_color = currentColor;
		currentMoveNum++;
		shiftTimer();

		drawBoard();

		if (passes == 2) {
		}
	} catch (...)	{
	}
}

void CZGoGUIView::OnGoComputerplayboth() 
{
	try {
		m_messageBox.Message("OnGoComputerplayboth, 1", "");
		computerPlayBoth = TRUE;
		movePara->passes = passes;
		movePara->currentColor = currentColor;
		movePara->i = last_i;
		movePara->j = last_j;
		movePara->m_hwndDrawBoard = m_hWnd;
		m_pComputerPlayBothThread = AfxBeginThread(computerPlayBothProc, movePara, 
			THREAD_PRIORITY_NORMAL, 0, 0, NULL );
	} catch (...)	{
	}
}

void CZGoGUIView::OnGoPass() 
{
	z_do_pass(&passes, currentColor);
}

void CZGoGUIView::OnGoUndomove() 
{
	z_undo_move();
	last_i = z_get_last_move_i();
	last_j = z_get_last_move_j();
	last_color = z_get_last_move_color();
	currentMoveNum--;
	setCurrentColor();

	drawBoard();
}

void CZGoGUIView::setCurrentColor()
{
	if (currentColor == 2) {
		currentColor = 1;
	}
	else {
		currentColor = 2;
	}
}

void CZGoGUIView::OnGoOptions() 
{
	int nResponse = dlgOption.DoModal();
	if (nResponse == IDOK)
	{
		dlgOption.getOption(&goOption);
		m_messageBox.Message("OnGoOptions 2,board_size=", goOption.board_size );
		m_messageBox.Message("OnGoOptions 2,computerPlay=", goOption.computerPlay );
	}
	bTimer.setTime(goOption.timer);
	wTimer.setTime(goOption.timer);
	goBoard.boardSize = goOption.board_size;
	goBoard.reset();
	drawBoard();
	int argc = 1;
	char* argv[1];
	argv[0] = "aaa";
	linkMain(&goOption, argc, argv);
	if (goOption.handicap > 0) {
		setCurrentColor();
		drawBoard();
	}
	if (goOption.computerPlay == BLACK) {
		OnGoComputermove();
	}
}

void CZGoGUIView::OpenFile(LPCTSTR lpszPathName)
{
	z_load_file((char*) lpszPathName);
	getGoData(&goData);
	currentMoveNum = goData.move_history_pointer;
	drawBoard();
}

void CZGoGUIView::OnGoShowdragons() 
{
	try {
		CFrameWnd* pNewFrame = theApp->m_pDragonViewTemplate->CreateNewFrame(GetDocument(), NULL);
		if (pNewFrame) {
			theApp->m_pDragonViewTemplate->InitialUpdateFrame(pNewFrame, GetDocument());

			// GET THE NEW ONE JUST CREATED HERE
			// SKIP THE OLD ONES FIRST
			POSITION pos=GetDocument()->GetFirstViewPosition();
			ASSERT(pos);
			CView* view;
			for (int i=0;i<GetDocument()->m_numActingViews+1;i++) {
				view= GetDocument()->GetNextView(pos);
				ASSERT(view);
			}	
			zGoWormView* goWormView=(zGoWormView*) GetDocument()->GetNextView(pos);
			ASSERT(goWormView);
			goWormView->goData = &goData;
			goWormView->drawContent = DRAW_DRAGON;
			GetDocument()->m_numActingViews++;
		}
		else {
			m_messageBox.Message("OpenDragonView 98,", "cant open dragon view" );
		}
	}
	catch (...)	{
			m_messageBox.Message("OpenDragonView 99,", "cant open dragon view" );
	}
}

void CZGoGUIView::OnGoShowworms() 
{
	try {
		CFrameWnd* pNewFrame = theApp->m_pDragonViewTemplate->CreateNewFrame(GetDocument(), NULL);
		if (pNewFrame) {
			theApp->m_pDragonViewTemplate->InitialUpdateFrame(pNewFrame, GetDocument());

			// GET THE NEW ONE JUST CREATED HERE
			// SKIP THE OLD ONES FIRST
			POSITION pos=GetDocument()->GetFirstViewPosition();
			ASSERT(pos);
			CView* view;
			for (int i=0;i<GetDocument()->m_numActingViews+1;i++) {
				view= GetDocument()->GetNextView(pos);
				ASSERT(view);
			}	
			zGoWormView* goWormView=(zGoWormView*) GetDocument()->GetNextView(pos);
			ASSERT(goWormView);
			goWormView->goData = &goData;
			goWormView->drawContent = DRAW_WORM;
			GetDocument()->m_numActingViews++;
		}
		else {
			m_messageBox.Message("OpenDragonView 98,", "cant open dragon view" );
		}
	}
	catch (...)	{
			m_messageBox.Message("OpenDragonView 99,", "cant open dragon view" );
	}
}

void CZGoGUIView::OnGoScore() 
{
	zScore(&goData);
	goData.wScore=goData.wScore+goOption.komi;
	m_messageBox.Message("b prinsoner=", goData.wCaptured);
	m_messageBox.Message("b territory=", goData.bTerritory);
	m_messageBox.Message("b score=", goData.bScore);
	m_messageBox.Message("w komi=", goOption.komi);
	m_messageBox.Message("w prinsoner=", goData.bCaptured);
	m_messageBox.Message("w territory=", goData.wTerritory);
	m_messageBox.Message("w score=", goData.wScore);
}
/*
void CZGoGUIView::goTop()
{
	m_messageBox.Message("goTop", "");
	//currentMoveNum = goData.move_history_pointer;
	currentMoveNum = 1;
	drawBoard();
}

void CZGoGUIView::forWard()
{
	currentMoveNum++;
	drawBoard();
}

void CZGoGUIView::backWard()
{
	currentMoveNum--;
	drawBoard();
}

void CZGoGUIView::goEnd()
{
	currentMoveNum = goData.move_history_pointer;
	drawBoard();
}
*/
void CZGoGUIView::shiftTimer()
{
	m_messageBox.Message("shiftTimer, 1", "");
	if (currentColor == BLACK) {
		bTimer.stop();
		wTimer.start();
	}
	if (currentColor == WHITE) {
		wTimer.stop();
		bTimer.start();
	}
}

void CZGoGUIView::UpdateStatusBar()
{
		CMainFrame* frame=(CMainFrame*) AfxGetApp()->m_pMainWnd;
		CString tmp;
		tmp.Format(" wCapture:%i  bCapture:%i total:%i move:%i", goData.wCaptured,goData.bCaptured,goData.move_history_pointer,currentMoveNum);
		frame->SetMessageText("wTimer:"+wTimer.toString()+
			 " bTimer:"+bTimer.toString()+tmp);
}

void CZGoGUIView::OnNevigateTop() 
{
	m_messageBox.Message("goTop", "");
	//currentMoveNum = goData.move_history_pointer;
	currentMoveNum = 1;
	drawBoard();
}

void CZGoGUIView::OnNevigateBackward() 
{
	currentMoveNum--;
	drawBoard();
}

void CZGoGUIView::OnNevigateForward() 
{
	currentMoveNum++;
	drawBoard();
}

void CZGoGUIView::OnNevigateEnd() 
{
	currentMoveNum = goData.move_history_pointer;
	drawBoard();
}
