// zGoWormView.cpp : implementation file
//

#include "stdafx.h"
#include "zGoGUI.h"
#include "zGoWormView.h"

#include "comdef.h"
#include "process.h"
#include "mmsystem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern zMessageBox m_messageBox;

/////////////////////////////////////////////////////////////////////////////
// zGoWormView

IMPLEMENT_DYNCREATE(zGoWormView, CView)

zGoWormView::zGoWormView()
{
}

zGoWormView::~zGoWormView()
{
}


BEGIN_MESSAGE_MAP(zGoWormView, CView)
	//{{AFX_MSG_MAP(zGoWormView)
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_ANALYZE_LOCALGUANGZI, OnAnalyzeLocalguangzi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CZGoGUIDoc* zGoWormView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CZGoGUIDoc)));
	return (CZGoGUIDoc*)m_pDocument;
}
/////////////////////////////////////////////////////////////////////////////
// zGoWormView drawing

void zGoWormView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	drawBoard();
}

/////////////////////////////////////////////////////////////////////////////
// zGoWormView diagnostics

#ifdef _DEBUG
void zGoWormView::AssertValid() const
{
	CView::AssertValid();
}

void zGoWormView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// zGoWormView message handlers

void zGoWormView::drawBoard()
{
		m_messageBox.Message("drawBoard ","");

		if (drawContent == DRAW_DRAGON) {
			drawDragon();
		}

		if (drawContent == DRAW_WORM) {
			drawWorm();
		}

}

void zGoWormView::drawDragon()
{
	int i,j,id,color;
	CClientDC dc(this);
	m_messageBox.Message("drawDragon ","");
		
	goBoard.boardSize = goData->board_size;
	goBoard.reset();
	goBoard.drawBoardbase(&dc);

	for (i = 0; i < goData->board_size; i++) {
		for (j = 0; j < goData->board_size; j++) {
			dragon_data *dragon1 = &(goData->dragon1[POS(i,j)]);
			id = dragon1->id;
			color = goData->board[POS(i,j)];
			if (color > 0) {
				goBoard.drawDragonStone(&dc,i,j,color,id);
			}
		}
	}
}

void zGoWormView::drawWorm()
{
	int i,j,origin,color;
	CClientDC dc(this);
	m_messageBox.Message("drawWorm ","");
		
	goBoard.boardSize = goData->board_size;
	goBoard.reset();
	goBoard.drawBoardbase(&dc);

	for (i = 0; i < goData->board_size; i++) {
		for (j = 0; j < goData->board_size; j++) {
			worm_data *worm = &(goData->worm[POS(i,j)]);
			origin = worm->origin;
			color = worm->color;
			m_messageBox.Message("drawWorm origin=",origin);
			//color = goData->board[POS(i,j)];
			//if (color > 0) {
				goBoard.drawDragonStone(&dc,i,j,color,origin);
			//}
		}
	}
}

void zGoWormView::OnDestroy() 
{
	CView::OnDestroy();
	GetDocument()->m_numActingViews--;
}

void zGoWormView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	try {
		CPoint goBoardPoint;
		goBoard.screenCoorToBoardCoor(point, &goBoardPoint);
		int i = goBoardPoint.x;
		int j = goBoardPoint.y;
		if (drawContent == DRAW_DRAGON) {
			ShowDragonAtt(i,j);
		}
		if (drawContent == DRAW_WORM) {
			ShowWormAtt(i,j);
		}
	} catch (...)	{
	}
	CView::OnLButtonDown(nFlags, point);
}

void zGoWormView::ShowDragonAtt(int i, int j)
{
		dragon_data *dragon1 = &(goData->dragon1[POS(i,j)]);
		m_messageBox.Message("id= ", dragon1->id);
		m_messageBox.Message("size= ", dragon1->size);
		m_messageBox.Message("effective_size= ", dragon1->effective_size);
		m_messageBox.Message("status= ", dragon1->status);
		dragon_data2 *dragon2 = &(goData->dragon2[dragon1->id]);
		m_messageBox.Message("origin= ", dragon2->origin);
		m_messageBox.Message("genus= ", dragon2->genus);
		m_messageBox.Message("neighbors= ", dragon2->neighbors);
		m_messageBox.Message("hostile_neighbors= ", dragon2->hostile_neighbors);
		m_messageBox.Message("safety= ", dragon2->safety);
		m_messageBox.Message("escape_route= ", dragon2->escape_route);
		m_messageBox.Message("genus= ", dragon2->genus);
		m_messageBox.Message("heyes= ", dragon2->heyes);
		m_messageBox.Message("heye= ", dragon2->heye);
		m_messageBox.Message("lunch= ", dragon2->lunch);
		m_messageBox.Message("semeai= ", dragon2->semeai);
		m_messageBox.Message("semeai_margin_of_safety= ", dragon2->semeai_margin_of_safety);
}

void zGoWormView::ShowWormAtt(int i, int j)
{
		worm_data *worm = &(goData->worm[POS(i,j)]);
		m_messageBox.Message("origin= ", worm->origin);
		m_messageBox.Message("size= ", worm->size);
		m_messageBox.Message("effective_size= ", worm->effective_size);
		m_messageBox.Message("color= ", worm->color);
		m_messageBox.Message("liberties= ", worm->liberties);
		m_messageBox.Message("liberties2= ", worm->liberties2);
		m_messageBox.Message("liberties3= ", worm->liberties3);
		m_messageBox.Message("liberties4= ", worm->liberties4);
		m_messageBox.Message("lunch= ", worm->lunch);
		m_messageBox.Message("cutstone= ", worm->cutstone);
		m_messageBox.Message("cutstone2= ", worm->cutstone2);
		m_messageBox.Message("genus= ", worm->genus);
		m_messageBox.Message("inessential= ", worm->inessential);
		m_messageBox.Message("invincible= ", worm->invincible);
		m_messageBox.Message("unconditional_status= ", worm->unconditional_status);
}

void zGoWormView::OnAnalyzeLocalguangzi() 
{
	int dragonNum1, dragonNum2;
	int nResponse;
	nResponse = dlgLocalGaungzi.DoModal();
	if (nResponse == IDOK)
	{
		dlgLocalGaungzi.getDragonNum(&dragonNum1,&dragonNum2);
		m_messageBox.Message("OnAnalyzeLocalguangzi 2,dragonNum1=", dragonNum1);
		m_messageBox.Message("OnAnalyzeLocalguangzi 2,dragonNum2=", dragonNum2);
		localGuangzi(dragonNum1,dragonNum2);
	}
}
